# Enum Class VulkanSystemAllocationScope

java.lang.Object
java.lang.Enum<VulkanSystemAllocationScope>
com.io7m.jcoronado.api.VulkanSystemAllocationScope

All Implemented Interfaces:
  `VulkanEnumIntegerType`, `Serializable`, `Comparable<VulkanSystemAllocationScope>`, `Constable`

public enum VulkanSystemAllocationScope extends Enum<VulkanSystemAllocationScope> implements VulkanEnumIntegerType
Allocation scope.

See Also:
  - "VkSystemAllocationScope"

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `VK_SYSTEM_ALLOCATION_SCOPE_CACHE`
  Specifies that the allocation is scoped to the lifetime of a VkPipelineCache or VkValidationCacheEXT object.
  `VK_SYSTEM_ALLOCATION_SCOPE_COMMAND`
  Specifies that the allocation is scoped to the duration of the Vulkan command.
  `VK_SYSTEM_ALLOCATION_SCOPE_DEVICE`
  Specifies that the allocation is scoped to the lifetime of the Vulkan device.
  `VK_SYSTEM_ALLOCATION_SCOPE_INSTANCE`
  Specifies that the allocation is scoped to the lifetime of the Vulkan instance.
  `VK_SYSTEM_ALLOCATION_SCOPE_OBJECT`
  Specifies that the allocation is scoped to the lifetime of the Vulkan object that is being created or used.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanSystemAllocationScope`
  `ofInt(int index)`
  Create a scope from the given integer.
  `int`
  `value()`
  `static VulkanSystemAllocationScope`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static VulkanSystemAllocationScope[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### VK_SYSTEM_ALLOCATION_SCOPE_COMMAND

    public static final VulkanSystemAllocationScope VK_SYSTEM_ALLOCATION_SCOPE_COMMAND
    Specifies that the allocation is scoped to the duration of the Vulkan command.

  - ### VK_SYSTEM_ALLOCATION_SCOPE_OBJECT

    public static final VulkanSystemAllocationScope VK_SYSTEM_ALLOCATION_SCOPE_OBJECT
    Specifies that the allocation is scoped to the lifetime of the Vulkan object that is being created or used.

  - ### VK_SYSTEM_ALLOCATION_SCOPE_CACHE

    public static final VulkanSystemAllocationScope VK_SYSTEM_ALLOCATION_SCOPE_CACHE
    Specifies that the allocation is scoped to the lifetime of a VkPipelineCache or VkValidationCacheEXT object.

  - ### VK_SYSTEM_ALLOCATION_SCOPE_DEVICE

    public static final VulkanSystemAllocationScope VK_SYSTEM_ALLOCATION_SCOPE_DEVICE
    Specifies that the allocation is scoped to the lifetime of the Vulkan device.

  - ### VK_SYSTEM_ALLOCATION_SCOPE_INSTANCE

    public static final VulkanSystemAllocationScope VK_SYSTEM_ALLOCATION_SCOPE_INSTANCE
    Specifies that the allocation is scoped to the lifetime of the Vulkan instance.

- ## Method Details

  - ### values

    public static VulkanSystemAllocationScope[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static VulkanSystemAllocationScope valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### ofInt

    public static VulkanSystemAllocationScope ofInt(int index)
    Create a scope from the given integer.
    Parameters:
      `index` - The integer value
    Returns:
      The scope associated with the integer

  - ### value

    public int value()
    Specified by:
      `value` in interface `VulkanEnumIntegerType`
    Returns:
      The integer value of the constant